unit ad24usbd;

{$define USE_DLL}

interface

{$ifdef USE_DLL}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;
{$else}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,ad24usbdriv;
{$endif}


type
  TForm1 = class(TForm)
    StartB: TButton;
    Channel0: TLabel;
    Gain: TRadioGroup;
    Stoptl: TButton;
    Resol: TRadioGroup;
    DebugL: TLabel;
    Timer1: TTimer;
    CheckBox1: TCheckBox;
    ChopperBox: TCheckBox;
    procedure start(Sender: TObject);
    procedure StoptlClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ontimer;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  const
        Ptac : double = 3.9083e-3 ;
        Ptbc : double = -5.775e-7 ;
        Ptcc : double = -4.183e-12;   {constants for Pt100 polynomial}

var
  Form1: TForm1;
  range:integer;
  rangeb : byte;
  Stop : boolean;

implementation

{$R *.DFM}
{$ifdef USE_DLL}
  function InitAD:integer ;stdcall; external 'ad24usb.dll'
  procedure closeAD ;stdcall; external 'ad24usb.dll'
  procedure DAC(value:word);stdcall; external 'ad24usb.dll'
  procedure calibration(typ,range,resol:integer);stdcall; external 'ad24usb.dll' {kalibrace 0 - jednoho rangeu}
  procedure SetRange(typr:integer);stdcall; external 'ad24usb.dll'
  procedure SetChop(typchop,pocvz:integer);stdcall; external 'ad24usb.dll'
  function Adconv(resol,range,chan:integer):double;stdcall; external 'ad24usb.dll'
  function GetSample(range:byte):double;stdcall; external 'ad24usb.dll'  {prevezme 1 hodnotu v period. mereni}
  function GetCurrentRange:integer;stdcall; external 'ad24usb.dll'
  function GetDACresolution:integer;stdcall; external 'ad24usb.dll'
  function GetSerialN:integer;stdcall; external 'ad24usb.dll'
  procedure ProgEn(chan,resol:byte);stdcall; external 'ad24usb.dll' {pocet kanalu a rozliseni}
  procedure ProgCh(chan,gain:byte);stdcall; external 'ad24usb.dll' {vstup a zesileni}
  procedure Timer(burst:byte;time:word);stdcall; external 'ad24usb.dll' {burst-1 ano, cas v ms}
  procedure StartAD;stdcall; external 'ad24usb.dll'
  procedure StopAD;stdcall; external 'ad24usb.dll'
  procedure DigOut(value:byte);stdcall; external 'ad24usb.dll'
  function DigIn:byte;stdcall;  external 'ad24usb.dll'
{$endif}

procedure TForm1.start(Sender: TObject);
var resolp:integer;
    res,unip:integer;
    dresol,drange,serialn,chan: integer;
    u,r,r0,t,pta,ptb,ptc:double;
    ustr:string;

begin
  res := InitAD;  {module initialization, }
  if res=-0 then
    begin
      ShowMessage('AD24USB not connected to USB');
      Exit;
    end;
  if res= -1 then
    begin
      ShowMessage('AD24USB not respond');
      Exit;
    end;
  DigOut($ff);  //digital Out
  DigOut(0);
  resolp:=DigIn; //digital In
  if CheckBox1.Checked then SetRange(0) else SetRange(1);  //unipolar/bipolar range
  chan := 8; //kanal

  DAC(000);
  dresol := GetDACresolution;
  drange := GetCurrentRange;
  serialn := GetSerialN;
  resolp:=resol.itemIndex+1;  //
  range := Gain.itemIndex;   //7 - gain 128(512 for diff version), 0 - gain 1
  if ChopperBox.Checked then  //input chopper diferential version only!
     begin
        SetRange(1);  // bipolar range
        resolp := 1;  // integration time 20 ms
        if resol.itemIndex < 2 then SetChop(1,4) //input Chopper, 4 samples for Tint <320 ms, else 16 samples
        else SetChop(1,16);
     end;
  Calibration(0,range,resolp); //Calibration - only selected range
  Stop := false;
//example program for single shot measurement
  repeat
  u:= ADConv(resolp,range,chan);   //
  if range < 3 then
    begin
      str(u:8:5,ustr);
      Channel0.Caption:='Channel '+inttostr(chan)+' = '+ustr+' V    ';
    end
  else
    begin
      str(u*1000:8:4,ustr);
      Channel0.Caption:='Channel '+inttostr(chan)+' = '+ustr+' mV    ';
    end;
  Application.ProcessMessages;
  until Stop;
//end of single shot mode



//example program for measurement in periodical mode, comment single shot mode first
  ProgEn(1,resolp);      //Program 1 channel in periodical mode
  rangeb := range;
  ProgCh(0,rangeb);         //Channel 0,
  Timer(1,1000);       //Burst mod, period 1000 ms
  StartAD;
  repeat
    ontimer;
    Application.ProcessMessages;
  until Stop;
  StopAD;
//end of  period. mod

end;

procedure TForm1.ontimer;
var u:double;
ustr:string;
begin
        u:=GetSample(range);
        if range < 3 then
          begin
            str(u:8:5,ustr);
            Channel0.Caption:='Channel 0 = '+ustr+' V    ';
          end
        else
          begin
            str(u*1000:8:4,ustr);
            Channel0.Caption:='Channel 0 = '+ustr+' mV    ';
          end;
end;




procedure TForm1.StoptlClick(Sender: TObject);
begin
  Stop := true;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Stop := true;
end;

end.
